//+------------------------------------------------------------------+
//|                              !_rdb_BuySell_Signal_with_LotMM.mq4 |
//|                                                    rahman_DGBeta |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "rahman_Dg_Beta"
#property link      "abdulrahman_maros@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Blue
#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 3

//---- input parameters

extern int     TF                   = 15;
extern bool    Show_Buy_Sell_Signal = false;
extern bool    Show_Signal_Harga    = false;
extern bool    Show_Lot_Management  = true;
extern bool    Show_My_Trend_Manual = false;
extern string  Trend_Manual         = "...";
extern int     Account_Type         = 100; //Dollar
extern double  Max_Lot              = 10; 
extern double  Percen_Lot           = 2.5; 
extern double  Percen_Lot_Strong    = 2.5; 
extern color   Lot_OK               = Green;
extern color   Lot_Stop             = Chocolate;
extern color   Lot_Netral           = DimGray;

extern bool Show_MA_Line   = false;
extern bool Show_MA1       = true;
extern bool Show_MA2       = true;
extern bool Show_MA3       = true;
extern int MA_Mode         = MODE_LWMA; //MODE_SMA
extern int MA_Type         = PRICE_TYPICAL;

extern string  MA1_Input            = "Parameter untuk MA1";
extern int     MA1_Period           = 6;
extern int     MA1_Shift            = 0;
extern int     MA1_Method           = 0;
extern int     MA1_Apply            = 1;
extern color   MA1_Color            = Red;

extern string  MA2_Input            = "Parameter untuk MA2";
extern int     MA2_Period           = 12;
extern int     MA2_Shift            = 0;
extern int     MA2_Method           = 0;
extern int     MA2_Apply            = 1;
extern color   MA2_Color            = Green;

extern string  MA3_Input            = "Parameter untuk MA3";
extern int     MA3_Period           = 48;
extern int     MA3_Shift            = 0;
extern int     MA3_Method           = 0;
extern int     MA3_Apply            = 1;
extern color   MA3_Color            = Blue;

extern string  DeMarker_Input       = "For Signal Overbought/Oversold";
extern double  Overbought           = 0.9;
extern double  Oversold             = 0.1;

extern double  x_offset      =0;
extern double  y_offset      =100;

extern string  CreatedBy            = "rahman_Dg_Beta";
extern string  Rule_for_This_System = "just for TF M5 & M15";
extern string  Indicator_Need       = "NonLagMA_v7.1-NRTR rosh-RadsT3";

int  signal_harga  = 1;
int   Sign_BS,show;

//+------------------------------------------------------------------+
int            StartYear=2007;      // Year to start (only for backtest)
int            StartMonth=1;        // month to start (only for backtest)
int            EndYear=2009;        // Year to stop trading (backtest and live)
int            EndMonth=12;         // Month to stop trading (backtest and live)
//+------------------------------------------------------------------+
   double longActive=0,  shortActive=0;
   double longStop=0,    shortStop=0;
   double longLimit=0,   shortLimit=0;
   
   double longPending=0, shortPending=0;
   double allLong=0,     allShort=0;
   double allActive=0,   allPending=0;
   double grandTotal=0;   
   
   
   double actualProfitMonitor=0;
   double actualProfitMonitor_pip=0;

   double ShortProfit=0;
   double LongProfit=0;

   double longActiveLot=0,  shortActiveLot=0, longActiveLot1=0,  shortActiveLot1=0;
   double longStopLot=0,    shortStopLot=0;
   double longLimitLot=0,   shortLimitLot=0;
   
   double longPendingLot=0, shortPendingLot=0;
   double allLongLot=0,     allShortLot=0;
   double allActiveLot=0,allActiveLot1=0,   allPendingLot=0;
   double grandTotalLot=0;   

   string TimeFrameStr;

//---- buffers
double MA1[];
double MA2[];
double MA3[];
int    Per1;
int    Per2;
int    Per3;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
if (Show_MA_Line==true)
   {
   SetIndexStyle(0,DRAW_LINE,0,2,MA1_Color);
   SetIndexBuffer(0,MA1);
   SetIndexStyle(1,DRAW_LINE,0,2,MA2_Color);
   SetIndexBuffer(1,MA2);
   SetIndexStyle(2,DRAW_LINE,0,2,MA3_Color);
   SetIndexBuffer(2,MA3);
   }
   //---- indicators
switch(TF)
   {
      case 1 : TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current TF"; TF=0;
   }

   IndicatorShortName("_rdb_Signal_BUY_SELL_v1");
//----
   return(0);
  }//init
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
     {
       string label = ObjectName(i);
       if(StringSubstr(label, 0, 5) != "_rdb_BuySell_Signal_with_LotMM_v1")
           continue;
       ObjectDelete(label);   
     }   
//----
   ObjectsDeleteAll(0,OBJ_LABEL);
   ObjectDelete("AM1"); ObjectDelete("AM2"); ObjectDelete("AM3");
   ObjectDelete("AM4"); ObjectDelete("AM5"); ObjectDelete("AM6");
   ObjectDelete("AM7"); ObjectDelete("AM8"); ObjectDelete("AM9");
   ObjectDelete("AM10"); ObjectDelete("AM11"); ObjectDelete("AM12");
//----
   return(0);
  }//deinit
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//+------------------------------------------------------------------+
    int counted_bars = IndicatorCounted();

   //double volume10  =iVolume(NULL,PERIOD_M1,0);
   //if(volume10>1) return;
//+------------------------------------------------------------------+

      if (TimeYear(CurTime())<StartYear)     { return(0);  }
      if (TimeMonth(CurTime())<StartMonth)   { return(0); }
      if (TimeYear(CurTime())>EndYear)       { return(0); }
      if (TimeMonth(CurTime())>EndMonth)     { return(0); }

   string mysymbol="", ms="";

   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD.") { mysymbol = "AUDCAD"; ms="ACAD";} else
   if (Symbol() == "AUDCHFm" || Symbol() == "AUDCHF.") { mysymbol = "AUDCHF"; ms="AC";} else
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY.") { mysymbol = "AUDJPY"; ms="AJ";} else
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD.") { mysymbol = "AUDNZD"; ms="AN";} else
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD.") { mysymbol = "AUDUSD"; ms="AU";} else
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY.") { mysymbol = "CHFJPY"; ms="CJ";} else
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD.") { mysymbol = "EURAUD"; ms="EA";} else
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD.") { mysymbol = "EURCAD"; ms="ECAD";} else
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF.") { mysymbol = "EURCHF"; ms="EC";} else
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP.") { mysymbol = "EURGBP"; ms="EG";} else
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY.") { mysymbol = "EURJPY"; ms="EJ";} else
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD.") { mysymbol = "EURUSD"; ms="EU";} else
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF.") { mysymbol = "GBPCHF"; ms="GC";} else
   if (Symbol() == "GBPCADm" || Symbol() == "GBPCAD.") { mysymbol = "GBPCAD"; ms="GCAD";} else
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY.") { mysymbol = "GBPJPY"; ms="GJ";} else
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD.") { mysymbol = "GBPUSD"; ms="GU";} else
   if (Symbol() == "NZDCADm" || Symbol() == "NZDCAD.") { mysymbol = "NZDCAD"; ms="NCAD";} else
   if (Symbol() == "NZDCHFm" || Symbol() == "NZDCHF.") { mysymbol = "NZDCHF"; ms="NC";} else
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY.") { mysymbol = "NZDJPY"; ms="NJ";} else
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD.") { mysymbol = "NZDUSD"; ms="NU";} else
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF.") { mysymbol = "USDCHF"; ms="UC";} else
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY.") { mysymbol = "USDJPY"; ms="UJ";} else
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD.") { mysymbol = "USDCAD"; ms="UCAD";} else
                              { mysymbol = Symbol(); }

   int ActivePer=Period();
   Per1=60/ActivePer;
   Per2=30/ActivePer;
   Per3=15/ActivePer;
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(int i=0; i<limit; i++)
   { 
      if (Show_MA1==true)   { MA1[i]=iMA(NULL,0,MA1_Period,MA1_Shift,MA1_Method,MA1_Apply,i); }
      if (Show_MA2==true)   { MA2[i]=iMA(NULL,0,MA2_Period,MA2_Shift,MA2_Method,MA2_Apply,i); }
      if (Show_MA3==true)   { MA3[i]=iMA(NULL,0,MA3_Period,MA3_Shift,MA3_Method,MA3_Apply,i); }
   }

//----

   actualProfitMonitor=0; 
   actualProfitMonitor_pip=0;
   ShortProfit=0; 
   LongProfit=0;

   longActive=0;  shortActive=0;
   longStop=0;    shortStop=0;
   longLimit=0;   shortLimit=0;
   longPending=0; shortPending=0;
   allLong=0;     allShort=0;
   allActive=0;   allPending=0;
   grandTotal=0;   

   longActiveLot=0;  shortActiveLot=0;  longActiveLot1=0;  shortActiveLot1=0;
   longStopLot=0;    shortStopLot=0;
   longLimitLot=0;   shortLimitLot=0;
   longPendingLot=0; shortPendingLot=0;
   allLongLot=0;     allShortLot=0;
   allActiveLot=0;   allActiveLot1=0; allPendingLot=0;
   grandTotalLot=0;   

   double   mylotbl=0,myloteq=0,Max_Lot1=0,Percen_Lot1=0,Percen_Lot2=0,Long_Active_Lot=0,Short_Active_Lot=0,Net_Lot=0,Percen_NetLot,
            Percen_LotB=0,Percen_LotS=0,Percen_LotBS=0,Profit_Loss=0,LotHere=0,AllLotPercen=0,MyLotPercen=0;

   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderType()==OP_BUY)
            {
            longActive++; 
            actualProfitMonitor += OrderProfit();
            actualProfitMonitor_pip += ( (OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_BID)) / (MarketInfo(OrderSymbol(),MODE_POINT)) );
            longActiveLot += OrderLots();
            }
            if((OrderSymbol()==Symbol()) && (OrderType()==OP_BUY))
            {
            longActiveLot1 += OrderLots();LongProfit += OrderProfit();
            }
         else 
         if (OrderType()==OP_SELL)
            {
            shortActive++; 
            actualProfitMonitor += OrderProfit();


            }
            if((OrderSymbol()==Symbol()) && (OrderType()==OP_SELL))
            {
            shortActiveLot1 += OrderLots(); ShortProfit += OrderProfit();
            }
         else 
         if (OrderType()==OP_BUYSTOP)
            longStop++;
         else 
         if (OrderType()==OP_SELLSTOP)


         if (OrderType()==OP_BUYLIMIT)
            longLimit++;
         else 
         if (OrderType()==OP_SELLLIMIT)
            shortLimit++;
   }//for

   longPending  = longStop + longLimit;
   shortPending = shortStop + shortLimit;
   allPending   = longPending + shortPending;
   allActive    = longActive + shortActive;
   allLong      = longStop + longLimit + longActive;
   allShort     = shortStop + shortLimit + shortActive;
   grandTotal   = allActive + allPending;

   longPendingLot  = longStopLot + longLimitLot;
   shortPendingLot = shortStopLot + shortLimitLot;
   allPendingLot   = longPendingLot + shortPendingLot;
   allLongLot      = longStopLot + longLimitLot + longActiveLot;
   allShortLot     = shortStopLot + shortLimitLot + shortActiveLot;
   grandTotalLot   = allActiveLot + allPendingLot;
     
   allActiveLot    = longActiveLot + shortActiveLot;
   allActiveLot1   = longActiveLot1 + shortActiveLot1;
   
   mylotbl          = AccountBalance()/Account_Type;
   myloteq          = AccountEquity()/Account_Type;
   Max_Lot1         = (Max_Lot/myloteq)*100;
   Percen_Lot1      = (Percen_Lot*myloteq)/100;             // 5*2/100=0.1 lot
   Percen_Lot2      = (Percen_Lot_Strong*myloteq)/100;      //10*2/100=0.2 lot
   
   Long_Active_Lot  = longActiveLot1;     
   Short_Active_Lot = shortActiveLot1;           
   Net_Lot          = longActiveLot1-shortActiveLot1;           

   Percen_LotB      = (Long_Active_Lot/myloteq)*100;           
   Percen_LotS      = (Short_Active_Lot/myloteq)*100;          //0.1/2*100 =5%
   Percen_LotBS     = ((Long_Active_Lot+Short_Active_Lot)/myloteq)*100;
   if(longActiveLot1-shortActiveLot1>0)   Percen_NetLot = ((longActiveLot1-shortActiveLot1)/myloteq)*100; else
   if(longActiveLot1-shortActiveLot1<0)   Percen_NetLot = (((longActiveLot1-shortActiveLot1)*(-1))/myloteq)*100;

   Profit_Loss      = LongProfit+ShortProfit;
   LotHere          = Long_Active_Lot+Short_Active_Lot;

   AllLotPercen     = (allActiveLot/myloteq)*100;
   MyLotPercen      = (myloteq/mylotbl)*100;
   
//+------------------------------------------------------------------+
   double close      =iClose     (NULL,PERIOD_M1  ,0);   

   double DM5        = iDeMarker (NULL,PERIOD_M5  ,14,0);
   double DM15       = iDeMarker (NULL,PERIOD_M15 ,14,0);
   double NL_BS      = iCustom   (NULL,PERIOD_M5  ,"NonLagMA_v7.1",0,9,0,0,1,1,0,0,0,0,0);

   double BB2_M1   =iCustom(NULL, PERIOD_M1, "BBands_Stop_v1", 20, 1, 0.5, 1, 1, 500,false,"","", 4,0); //UpTrendLine
   double BB1_M1   =iCustom(NULL, PERIOD_M1, "BBands_Stop_v1", 20, 1, 0.5, 1, 1, 500,false,"","", 5,0); //DownTrendLine

   double BB2_M5   =iCustom(NULL, PERIOD_M5, "BBands_Stop_v1", 20, 1, 0.5, 1, 1, 500,false,"","", 4,0); //UpTrendLine
   double BB1_M5   =iCustom(NULL, PERIOD_M5, "BBands_Stop_v1", 20, 1, 0.5, 1, 1, 500,false,"","", 5,0); //DownTrendLine

   double MA1_M1   = iMA   (Symbol(),PERIOD_M1,MA1_Period,MA1_Shift,MA1_Method,MA1_Apply,0);
   double MA2_M1   = iMA   (Symbol(),PERIOD_M1,MA2_Period,MA2_Shift,MA2_Method,MA2_Apply,0);
   double MA3_M1   = iMA   (Symbol(),PERIOD_M1,MA3_Period,MA3_Shift,MA3_Method,MA3_Apply,0);

   double MA1      = iMA   (Symbol(),TF,MA1_Period,MA1_Shift,MA1_Method,MA1_Apply,0);
   double MA2      = iMA   (Symbol(),TF,MA2_Period,MA2_Shift,MA2_Method,MA2_Apply,0);
   double MA3      = iMA   (Symbol(),TF,MA3_Period,MA3_Shift,MA3_Method,MA3_Apply,0);
//+---------------------------------------------------------------------------------------------------------------------------
//+----------------- 
//+------------------------------------------------------------------+
    string  trend_bs = "", trend_bs1 = "", level_bs = "";
    double  order_lot = 0, my_lot10=0;
    color   color_bs;
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+----------------- Signal BUY_SELL
 // BUY  EXECUTOR--------------------------------------------------------------------------------------------------------------  +
//+----------------- 
 // BUY  EXECUTOR--------------------------------------------------------------------------------------------------------------  +
   if   ((close>MA1)&&(close>MA2)&&(close>MA3)&&(MA1>MA2)&&(close>MA3_M1)&&(close>MA2_M1)&&(BB1_M1>BB2_M1)&&(BB1_M5>BB2_M5)&&((DM15<Overbought)||(DM5<Overbought)))    //Buy Double
         {Sign_BS=11;}
   else
   if   ((close>MA1)&&(close>MA2)&&((close<MA3)||(close>MA3))&&((MA1>MA2)||(MA1<MA2))&&((MA1>MA3)||(MA1<MA3))&&(BB1_M1>BB2_M1)&&(BB1_M5>BB2_M5)&&((DM15<Overbought)||(DM5<Overbought)))    //Buy
         {Sign_BS=12;}
   else
   if   ((close<MA1)&&(close>MA2)&&((close<MA3)||(close>MA3))&&((MA1>MA2)||(MA1<MA2))&&((MA1>MA3)||(MA1<MA3))&&(BB1_M1>BB2_M1)&&((DM15<Overbought)||(DM5<Overbought)))    //Buy Kuning
         {Sign_BS=15;}
   else
   if   ((DM15>Overbought)||(DM5>Overbought))
         {Sign_BS=14;} // buy Overbought
   else  
 // SELL EXECUTOR--------------------------------------------------------------------------------------------------------------  +
   if   ((close<MA1)&&(close<MA2)&&(close<MA3)&&(MA1<MA2)&&(close<MA3_M1)&&(close<MA2_M1)&&(BB1_M1<BB2_M1)&&(BB1_M5<BB2_M5)&&((DM15>Oversold)||(DM5>Oversold)))    //Sell Double
         {Sign_BS=21;}
   else
   if   ((close<MA1)&&(close<MA2)&&((close<MA3)||(close>MA3))&&((MA1<MA2)||(MA1>MA2))&&((MA1<MA3)||(MA1>MA3))&&(BB1_M1<BB2_M1)&&(BB1_M5<BB2_M5)&&((DM15>Oversold)||(DM5>Oversold)))    //Sell
         {Sign_BS=22;}
   else
   if   ((close>MA1)&&(close<MA2)&&((close>MA3)||(close<MA3))&&((MA1<MA2)||(MA1>MA2))&&((MA1<MA3)||(MA1>MA3))&&(BB1_M1<BB2_M1)&&((DM15>Oversold)||(DM5>Oversold)))    //Sell Kuning
         {Sign_BS=25;}
   else
   if   ((DM15<Oversold)||(DM5<Oversold))
         {Sign_BS=24;} // sell Oversold

   else  {Sign_BS=3;}    //Sideway

//+------------------------------------------------------------------+
//+- TREND UP BS
    if (Sign_BS==11)
        {trend_bs = "Buy  Strong";  trend_bs1 = "Buy";  order_lot=Percen_Lot2 ; color_bs = DodgerBlue;}   else
    if (Sign_BS==12)
        {trend_bs = "B u y     ";  trend_bs1 = "Buy";  order_lot=Percen_Lot1 ; color_bs = DodgerBlue;}   else
    if (Sign_BS==15)
        {trend_bs = "B u y     ";  trend_bs1 = "Buy";  order_lot=Percen_Lot1 ; color_bs = Gold;}   else
    if (Sign_BS==13)
        {trend_bs = "Close Buy";  trend_bs1 = "CloseB";  color_bs = Brown;}   else

//+- TREND DN BS
    if (Sign_BS==21)
        {trend_bs = "Sell  Strong";  trend_bs1 = "Sell";  order_lot=Percen_Lot2 ; color_bs = Brown;}   else
    if (Sign_BS==22)
        {trend_bs = "S e l l    ";  trend_bs1 = "Sell";  order_lot=Percen_Lot1 ; color_bs = Brown;}   else
    if (Sign_BS==25)
        {trend_bs = "S e l l    ";  trend_bs1 = "Sell";  order_lot=Percen_Lot1 ; color_bs = Gold;}   else
    if (Sign_BS==23)
        {trend_bs = "Close Sell ";  trend_bs1 = "CloseS";  color_bs = DodgerBlue;}   else

    if (Sign_BS==3)
        {trend_bs = "No Signal";  trend_bs1 = "Wait";  color_bs = Silver;}
        
    if (Sign_BS==14)
        {trend_bs = "Overbought";  trend_bs1 = "OverB";  color_bs = Brown;}   else
    if (Sign_BS==24)
        {trend_bs = "Oversold";  trend_bs1 = "OverS";  color_bs = DodgerBlue;}   
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int x,y,xA,yA,sebelah;

    sebelah=1;
    
    xA=x_offset+5;
    yA=y_offset;

//+------------------------------------------------------------------+
if (Show_Signal_Harga==true)
   {
   string  trend_harga="";
   ObjectDelete("time");

   if (signal_harga==1) trend_harga=trend_bs1;

   if(ObjectFind("time") != 0)
   {
   ObjectCreate("time", OBJ_TEXT, 0, Time[0], Bid);
   ObjectSetText("time", "           "+trend_harga+"", 7, "Arial Bold", color_bs);

   }//ObjectFind
   else
   {
   ObjectMove("time" , 0, Time[0], Bid);
//   ObjectMove("time1", 0, Time[0], Bid);
   }//else
   }//Show_Signal_Harga
if (Show_Signal_Harga==false)
   {
   ObjectDelete("time");
   }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
    y=10;
    x=10;  

if(Show_Buy_Sell_Signal==true)
   {
    sebelah=1;
    ObjectCreate("AM1", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM1",trend_bs,15, "Monotype Corsiva", color_bs);
        ObjectSet("AM1", OBJPROP_CORNER, sebelah);
        ObjectSet("AM1", OBJPROP_XDISTANCE, x+xA+4);
        ObjectSet("AM1", OBJPROP_YDISTANCE, y+yA);
    ObjectCreate("AM2", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM2",trend_bs,15, "Monotype Corsiva", DimGray);
        ObjectSet("AM2", OBJPROP_CORNER, sebelah);
        ObjectSet("AM2", OBJPROP_XDISTANCE, x+xA+3);
        ObjectSet("AM2", OBJPROP_YDISTANCE, y+yA+1);
   }//Show_Buy_Sell_Signal
//+------------------------------------------------------------------+
   double   y2=13, x2=-14;
   color profit_color;
   y=10;
   x=15;  

if(Show_Lot_Management==true)
   {
      if((Percen_LotB+Percen_LotS)<((Percen_Lot+Percen_Lot_Strong)*1.5)) 
         {
         ObjectCreate("AM3", OBJ_LABEL, 0, 0, 0);
             ObjectSetText("AM3","OP_Lot = "+DoubleToStr(order_lot,2),9, "Arial Bold", color_bs);
             ObjectSet("AM3", OBJPROP_CORNER, sebelah);
             ObjectSet("AM3", OBJPROP_XDISTANCE, x+xA+x2);
             ObjectSet("AM3", OBJPROP_YDISTANCE, y+yA+(y2*2));
         }
      else
      if((Percen_LotB+Percen_LotS)>((Percen_Lot+Percen_Lot_Strong)*1.5)&&((Percen_LotB+Percen_LotS)<(Max_Lot)))
         {
         ObjectCreate("AM3", OBJ_LABEL, 0, 0, 0);
             ObjectSetText("AM3","Stop OP Here ("+DoubleToStr(order_lot,2)+")",9, "Arial Bold", color_bs);
             ObjectSet("AM3", OBJPROP_CORNER, sebelah);
             ObjectSet("AM3", OBJPROP_XDISTANCE, x+xA+x2);
             ObjectSet("AM3", OBJPROP_YDISTANCE, y+yA+(y2*2));
         }
      else
      if((Percen_LotB+Percen_LotS)>((Percen_Lot+Percen_Lot_Strong)*1.5)&&((Percen_LotB+Percen_LotS)>(Max_Lot)))
         {
         ObjectCreate("AM3", OBJ_LABEL, 0, 0, 0);
             ObjectSetText("AM3","Limit ORDER ("+DoubleToStr(order_lot,2)+")",10, "Arial Bold", Gold);
             ObjectSet("AM3", OBJPROP_CORNER, sebelah);
             ObjectSet("AM3", OBJPROP_XDISTANCE, x+xA+x2);
             ObjectSet("AM3", OBJPROP_YDISTANCE, y+yA+(y2*2));
         }
   else ObjectDelete("AM3"); 

   if(LotHere>0.001)
   {
   if(Long_Active_Lot>0.001 && Percen_LotB<Percen_Lot) profit_color=Lot_OK; else
   if(Long_Active_Lot>0.001 && Percen_LotB>Percen_Lot) profit_color=Lot_Stop; else
   profit_color=Lot_Netral;
    ObjectCreate("AM4", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM4","Buy L = "+DoubleToStr(Long_Active_Lot,2)+" ("+DoubleToStr(Percen_LotB,1)+"%)",8, "Arial", profit_color);
        ObjectSet("AM4", OBJPROP_CORNER, sebelah);
        ObjectSet("AM4", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM4", OBJPROP_YDISTANCE, y+yA+(y2*3.5));
        
   if(Short_Active_Lot>0.001 && Percen_LotS<Percen_Lot) profit_color=Lot_OK; else
   if(Short_Active_Lot>0.001 && Percen_LotS>Percen_Lot) profit_color=Lot_Stop; else
   profit_color=DimGray;
    ObjectCreate("AM5", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM5","Sell L = "+DoubleToStr(Short_Active_Lot,2)+" ("+DoubleToStr(Percen_LotS,1)+"%)",8, "Arial", profit_color);
        ObjectSet("AM5", OBJPROP_CORNER, sebelah);
        ObjectSet("AM5", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM5", OBJPROP_YDISTANCE, y+yA+(y2*4.5));

   if(((Percen_NetLot)>0)&&(Percen_NetLot)<((Percen_Lot_Strong))) profit_color=Lot_OK; else
   if(((Percen_NetLot)>0)&&(Percen_NetLot)>((Percen_Lot_Strong))) profit_color=Lot_Stop; else
   profit_color=Lot_Netral;
   if((Long_Active_Lot>Short_Active_Lot)) 
      {
      ObjectCreate("AM15", OBJ_LABEL, 0, 0, 0);
          ObjectSetText("AM15","NetBuy"+" = "+DoubleToStr(Net_Lot,2)+" ("+DoubleToStr(Percen_NetLot,1)+"%)",8, "Arial", DodgerBlue);//profit_color);
          ObjectSet("AM15", OBJPROP_CORNER, sebelah);
          ObjectSet("AM15", OBJPROP_XDISTANCE, x+xA+x2);
          ObjectSet("AM15", OBJPROP_YDISTANCE, y+yA+(y2*5.5));
       }else
   if((Long_Active_Lot<Short_Active_Lot)) 
      {
      ObjectCreate("AM15", OBJ_LABEL, 0, 0, 0);
          ObjectSetText("AM15","NetSell"+" = "+DoubleToStr(Net_Lot,2)+" ("+DoubleToStr(Percen_NetLot,1)+"%)",8, "Arial", Brown);//profit_color);
          ObjectSet("AM15", OBJPROP_CORNER, sebelah);
          ObjectSet("AM15", OBJPROP_XDISTANCE, x+xA+x2);
          ObjectSet("AM15", OBJPROP_YDISTANCE, y+yA+(y2*5.5));
       }else ObjectDelete("AM15");

   if((Percen_LotB+Percen_LotS)<((Percen_Lot+Percen_Lot_Strong)*1.5)) profit_color=Lot_OK; else
   if((Percen_LotB+Percen_LotS)>((Percen_Lot+Percen_Lot_Strong)*1.5)) profit_color=Lot_Stop; else
   profit_color=Lot_Netral;
    ObjectCreate("AM6", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM6",ms+"-L"+" = "+DoubleToStr(LotHere,2)+" ("+DoubleToStr(Percen_LotBS,1)+"%)",8, "Arial", profit_color);
        ObjectSet("AM6", OBJPROP_CORNER, sebelah);
        ObjectSet("AM6", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM6", OBJPROP_YDISTANCE, y+yA+(y2*6.5));
        
   if(AllLotPercen<Max_Lot) profit_color=Lot_OK; else
   if(AllLotPercen>Max_Lot) profit_color=Lot_Stop; else
   profit_color=Lot_Netral;
    ObjectCreate("AM7", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM7","All L =   "+DoubleToStr(allActiveLot,2)+" ("+DoubleToStr(AllLotPercen,1)+"%)",8, "Arial", profit_color);
        ObjectSet("AM7", OBJPROP_CORNER, sebelah);
        ObjectSet("AM7", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM7", OBJPROP_YDISTANCE, y+yA+(y2*8));

   if(MyLotPercen>80) profit_color=Lot_OK; else
   if(MyLotPercen<80) profit_color=Lot_Stop; else
   profit_color=Lot_Netral;
    ObjectCreate("AM8", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM8","My L = "+DoubleToStr(myloteq,2)+" ("+DoubleToStr(MyLotPercen,1)+"%)",8, "Arial", profit_color);
        ObjectSet("AM8", OBJPROP_CORNER, sebelah);
        ObjectSet("AM8", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM8", OBJPROP_YDISTANCE, y+yA+(y2*9));
        
   if(Profit_Loss>0.001) profit_color=Lot_OK; else
   if(Profit_Loss<0.001) profit_color=Lot_Stop; else
   profit_color=Lot_Netral;
    ObjectCreate("AM9", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("AM9","$ "+DoubleToStr(Profit_Loss,2),10, "Arial Bold", profit_color);
        ObjectSet("AM9", OBJPROP_CORNER, sebelah);
        ObjectSet("AM9", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM9", OBJPROP_YDISTANCE, y+yA+(y2*10));
//+------------------------------------------------------------------+
   ObjectCreate("AM17", OBJ_LABEL, 0, 0, 0);
       ObjectSetText("AM17","$ "+DoubleToStr(AccountBalance(),2), 10, "Arial Bold", DimGray);
        ObjectSet("AM17", OBJPROP_CORNER, sebelah);
        ObjectSet("AM17", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM17", OBJPROP_YDISTANCE, y+yA+(y2*11.3));
//+------------------------------------------------------------------+
   if(AccountEquity()>AccountBalance()) profit_color=DodgerBlue; else
   if(AccountEquity()<AccountBalance()) profit_color=Brown; else
   profit_color=Lot_Netral;
   ObjectCreate("AM10", OBJ_LABEL, 0, 0, 0);
       ObjectSetText("AM10","$ "+DoubleToStr(AccountEquity(),2), 14, "Times New Roman", profit_color);
        ObjectSet("AM10", OBJPROP_CORNER, sebelah);
        ObjectSet("AM10", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM10", OBJPROP_YDISTANCE, y+yA+(y2*12.4));
//+------------------------------------------------------------------+
   ObjectDelete("AM14"); 
    }//LotHere
   else
   if(LotHere==0)
   {
//+------------------------------------------------------------------+
   ObjectCreate("AM17", OBJ_LABEL, 0, 0, 0);
       ObjectSetText("AM17","$ "+DoubleToStr(AccountBalance(),2), 10, "Arial Bold", DimGray);
        ObjectSet("AM17", OBJPROP_CORNER, sebelah);
        ObjectSet("AM17", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM17", OBJPROP_YDISTANCE, y+yA+(y2*3.5));
//+------------------------------------------------------------------+
   if(AccountEquity()>AccountBalance()) profit_color=DodgerBlue; else
   if(AccountEquity()<AccountBalance()) profit_color=Brown; else
   profit_color=Lot_Netral;
   ObjectCreate("AM14", OBJ_LABEL, 0, 0, 0);
       ObjectSetText("AM14","$ "+DoubleToStr(AccountEquity(),2), 14, "Times New Roman", profit_color);
        ObjectSet("AM14", OBJPROP_CORNER, sebelah);
        ObjectSet("AM14", OBJPROP_XDISTANCE, x+xA+x2);
        ObjectSet("AM14", OBJPROP_YDISTANCE, y+yA+(y2*5));
//+------------------------------------------------------------------+
   ObjectDelete("AM4"); ObjectDelete("AM5"); ObjectDelete("AM6");
   ObjectDelete("AM7"); ObjectDelete("AM8"); ObjectDelete("AM9");ObjectDelete("AM16");
   ObjectDelete("AM10"); ObjectDelete("AM11"); ObjectDelete("AM12");ObjectDelete("AM15");
   }//LotHere
   }//Show_Lot_Management
//+------------------------------------------------------------------+
   ObjectCreate("OMN000013", OBJ_LABEL, 0, 0, 0);
       ObjectSetText("OMN000013","Created by _rdb_ : abdulrahman_maros@yahoo.com",7, "Arial", DimGray);
       ObjectSet("OMN000013", OBJPROP_CORNER, 2);
       ObjectSet("OMN000013", OBJPROP_XDISTANCE, 5);
       ObjectSet("OMN000013", OBJPROP_YDISTANCE, 5);
//+------------------------------------------------------------------+
   if(Show_My_Trend_Manual==true)
   {
//+------------------------------------------------------------------+
   ObjectCreate("AM117", OBJ_LABEL, 0, 0, 0);
       ObjectSetText("AM117",Trend_Manual, 10, "Arial Bold", DimGray);
        ObjectSet("AM117", OBJPROP_CORNER, 3);
        ObjectSet("AM117", OBJPROP_XDISTANCE, 75);
        ObjectSet("AM117", OBJPROP_YDISTANCE, 5);
    } else ObjectDelete("AM117"); 
//+------------------------------------------------------------------+

   return(0);
  }//start()
//+------------------------------------------------------------------+


