#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Red

#define  LENGTH		10000

double     ExtBuffer0[];
double     buffer1[10000], buffer2[10000];

int init()
{
   IndicatorBuffers(1);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtBuffer0);
   
   ArrayInitialize(buffer1,0.0);
   ArrayInitialize(buffer2,0.0);
   
   ArraySetAsSeries(buffer1,True);
   ArraySetAsSeries(buffer2,True);
   
   return(0);
}

int deinit()
{

   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   int limit, i;
   
   

   
   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   if (limit > LENGTH) limit = LENGTH;
  
   for(i=limit; i>=0; i--)  {

      buffer1[i] = iMA(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, i);
      double ma5 = iMAOnArray(buffer1,0, 10, 0, MODE_EMA, i);
      double diff=buffer1[i]-ma5;
      double indic=buffer1[i]+diff;

      //MM longue 25
      buffer2[i] = iMA(NULL, 0, 25, 0, MODE_EMA, PRICE_CLOSE, i);
      double ma5L = iMAOnArray(buffer2, 0, 25, 0, MODE_EMA, i);

      double diffL=buffer2[i]-ma5L;
      double indicL=buffer2[i]+diffL;

      ExtBuffer0[i]=indic-indicL;
   }


return(0);
}

