//+------------------------------------------------------------------+
//|                                                True Scalping.mq4 |
//|                                                          by Lewi |
//+------------------------------------------------------------------+
#property copyright "2005, Lewi"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   int err;
   
   GlobalVariableGet("LastPrice");
   err=GetLastError();
   if (err > 0)
      GlobalVariableSet("LastPrice",0);    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   GlobalVariableDel("LastPrice");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (GlobalVariableGet("LastPrice")==0)
   {
      OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,Ask+20*Point,NULL,0,0,Green);
      OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,Bid-20*Point,NULL,0,0,Red);
      GlobalVariableSet("LastPrice",Bid);    
   }
   else
   {
      if ((GlobalVariableGet("LastPrice") - Bid)*10000 > 20)
      {
         OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,Ask+20*Point,NULL,0,0,Green);
         OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,Bid-20*Point,NULL,0,0,Red);
         GlobalVariableSet("LastPrice",Bid);    
      }
      if ((GlobalVariableGet("LastPrice") - Bid)*10000 < -20)
      {
         OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,Ask+20*Point,NULL,0,0,Green);
         OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,Bid-20*Point,NULL,0,0,Red);
         GlobalVariableSet("LastPrice",Bid);    
      }
   }

   return(0);
  }
//+------------------------------------------------------------------+