#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Orange



//---- input parameters
extern int HistoryMax= 5000;
extern int pipsdiff= 5;
extern int Length=18;
//---- buffers


double BufferBuySignals[];
double BufferSellSignals[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //---- indicator line
   IndicatorBuffers(2);

   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BufferBuySignals);
   SetIndexArrow(0,108); //238
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,BufferSellSignals);
   SetIndexArrow(1,108); //238
   //----
   return(0);
}
  

int start()
{
  
   int i,shift, lastbar, 
        swing_in= 30, // extra 30 bars for swing in
        counted_bars= IndicatorCounted();

   lastbar= MathMin(HistoryMax, Bars-swing_in-1);

   SetIndexDrawBegin(0, Bars-lastbar);   
   SetIndexDrawBegin(1, Bars-lastbar);

   int j;
         
   for (shift=0;  shift < lastbar+swing_in;  shift++) {
          
   double EntryShort   =iHigh(Symbol(),Period(),Highest(Symbol(),Period(),MODE_HIGH,Length,shift))-(pipsdiff)*Point;
   double EntryLong  =iLow(Symbol(),Period(),Lowest (Symbol(),Period(),MODE_LOW, Length,shift))+pipsdiff*Point;
            
       BufferBuySignals[shift] = EntryLong;     
       BufferSellSignals[shift] = EntryShort;    
      
   }
   return(0);
}


