//+------------------------------------------------------------------+
//|                                                 club forex 2.mq4 |
//|                                Copyright  2005, Patrick Je Jan. |
//|                                         http://www.clubforex.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2005, Patrick Le Jan"
#property link      "http://www.clubforex.net"

#property indicator_chart_window

extern bool pivots = true;
extern double securite = 0.0010;
extern double slippage = 0.0002;
extern double nbbarres = 6;
extern double heure = 7.00;

double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;
double P=0;
double Q=0;
double ATR,ETYPE;
double risque,dif,profit,lots,Lots,ordre,cours,deltatp,deltastop,deltacours,I;
double tstoplong, tstopshort,tprofitlong,tprofitshort,X,Y,long,short,stop;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];
int cnt, ticket, total;

//+------------------------------------------------------------------+
//| initialisation                          |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| deinitialisation                       |
//+------------------------------------------------------------------+
int deinit()
  {
ObjectDelete("R1 Label"); 
ObjectDelete("R1 Line");
ObjectDelete("R2 Label");
ObjectDelete("R2 Line");
ObjectDelete("R3 Label");
ObjectDelete("R3 Line");
ObjectDelete("S1 Label");
ObjectDelete("S1 Line");
ObjectDelete("S2 Label");
ObjectDelete("S2 Line");
ObjectDelete("S3 Label");
ObjectDelete("S3 Line");

   return(0);
  }
//+------------------------------------------------------------------+
//| iteration                              |
//+------------------------------------------------------------------+
int start()
  {
//if(Period() > 1440)
//{
//Print("Erreur - la priode de graphisme est suprieure  la journe.");
//return(-1); // sortie
//}

//---- Nouveaux prix

ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);

yesterday_close = rates_d1[1][4];
yesterday_open = rates_d1[1][1];
today_open = rates_d1[0][1];
yesterday_high = rates_d1[1][3];
yesterday_low = rates_d1[1][2];
day_high = rates_d1[0][3];
day_low = rates_d1[0][2];


//---- Calculs

D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);
X = High[Highest(Symbol(),PERIOD_H1,MODE_HIGH,nbbarres,1)];
Y = Low[Lowest(Symbol(),PERIOD_H1,MODE_LOW,nbbarres,1)];

ATR = iATR(NULL,0,24,0);
ETYPE = iStdDev(NULL,0,4,MODE_SMA,ATR,0,0);
stop = ATR + (3*ETYPE);
profit = 2*stop;
cours = iClose(Symbol(),PERIOD_H1,0);
dif = iATR(NULL,1440,10,0);

// money management - % par rapport au disponible
risque = AccountEquity() * 0.02;
lots =  risque/(stop*10000);
Lots = lots/10;

long = Y + dif - securite - profit;
short = X - dif + securite + profit;
tstoplong = long - stop;
tprofitlong = long + profit;
tstopshort = short + stop;
tprofitshort = short - profit;

if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}

// insertion de texte sur le graphe
Comment("Haut= ",X ,"    Previous Days Range= ",Hour(),":",Minute(),"     NBlots= ",Lots,"\nBas= ",Y ,"    Current Days Range= ",nD,"\ncours= ",cours,"    Stop= ",stop,"   Dif= ",dif);


// Etiquettes des lignes sur le chart
   if (pivots==true)
   {
      if(ObjectFind("R1 label") != 0)
      {
      ObjectCreate("R1 label", OBJ_TEXT, 0, Time[20], long);
      ObjectSetText("R1 label", "long", 8, "Arial", White);
      }
      else
      {
      ObjectMove("R1 label", 0, Time[20], long);
      }

      if(ObjectFind("R2 label") != 0)
      {
      ObjectCreate("R2 label", OBJ_TEXT, 0, Time[20], tprofitlong);
      ObjectSetText("R2 label", "objectif long", 8, "Arial", White);
      }
      else
      {
      ObjectMove("R2 label", 0, Time[20], tprofitlong);
      }

      if(ObjectFind("R3 label") != 0)
      {
      ObjectCreate("R3 label", OBJ_TEXT, 0, Time[20], tstoplong);
      ObjectSetText("R3 label", "stop long", 8, "Arial", White);
      }
      else
      {
      ObjectMove("R3 label", 0, Time[20], tstoplong);
      }

      if(ObjectFind("S1 label") != 0)
      {
      ObjectCreate("S1 label", OBJ_TEXT, 0, Time[20], short);
      ObjectSetText("S1 label", "short", 8, "Arial", White);
      }
      else
      {
      ObjectMove("S1 label", 0, Time[20], short);
      }

      if(ObjectFind("S2 label") != 0)
      {
      ObjectCreate("S2 label", OBJ_TEXT, 0, Time[20], tprofitshort);
      ObjectSetText("S2 label", "objectif short", 8, "Arial", White);
      }
      else
      {
      ObjectMove("S2 label", 0, Time[20], tprofitshort);
      }

      if(ObjectFind("S3 label") != 0)
      {
      ObjectCreate("S3 label", OBJ_TEXT, 0, Time[20], tstopshort);
      ObjectSetText("S3 label", "stop short", 8, "Arial", White);
      }
      else
      {
      ObjectMove("S3 label", 0, Time[20], tstopshort);
      }

//---  Dessin des lignes sur le chart
      if(ObjectFind("S1 line") != 0)
      {
      ObjectCreate("S1 line", OBJ_HLINE, 0, Time[40], short);
      ObjectSet("S1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("S1 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("S1 line", 0, Time[40], short);
      }

      if(ObjectFind("S2 line") != 0)
      {
      ObjectCreate("S2 line", OBJ_HLINE, 0, Time[40], tprofitshort);
      ObjectSet("S2 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("S2 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("S2 line", 0, Time[40], tprofitshort);
      }

      if(ObjectFind("S3 line") != 0)
      {
      ObjectCreate("S3 line", OBJ_HLINE, 0, Time[40], tstopshort);
      ObjectSet("S3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("S3 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("S3 line", 0, Time[40], tstopshort);
      }

      if(ObjectFind("R1 line") != 0)
      {
      ObjectCreate("R1 line", OBJ_HLINE, 0, Time[40],long );
      ObjectSet("R1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("R1 line", OBJPROP_COLOR, LimeGreen);
      }
      else
      {
      ObjectMove("R1 line", 0, Time[40], long);
      }

      if(ObjectFind("R2 line") != 0)
      {
      ObjectCreate("R2 line", OBJ_HLINE, 0, Time[40], tprofitlong);
      ObjectSet("R2 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("R2 line", OBJPROP_COLOR, LimeGreen);
      }
      else
      {
      ObjectMove("R2 line", 0, Time[40], tprofitlong);
      }

      if(ObjectFind("R3 line") != 0)
      {
      ObjectCreate("R3 line", OBJ_HLINE, 0, Time[40], tstoplong);
      ObjectSet("R3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("R3 line", OBJPROP_COLOR, LimeGreen);
      }
      else
      {
      ObjectMove("R3 line", 0, Time[40], tstoplong);
      }
   }


 
//---- End Of Program
   return(0);
  }
//+------------------------------------------------------------------+