//+------------------------------------------------------------------+
//|                                                    pipbuffett.mq4 |
//|            Copyright  2005, Paul Heap, indo@easyforexsignals.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Paul Heap"
#property link      "http://www.easyforexsignals.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Purple
#property indicator_color2 DarkGreen



//---- input parameters
extern int HistoryMax= 200;
//---- buffers


double BufferBuySignals[];
double BufferSellSignals[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //---- indicator line
   IndicatorBuffers(2);

   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,BufferBuySignals);
   SetIndexArrow(0,233); //238
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,BufferSellSignals);
   SetIndexArrow(1,234); //238
   //----
   return(0);
}
  

int start()
{
  
   int i,shift, lastbar, 
        swing_in= 0, // extra 30 bars for swing in
        counted_bars= IndicatorCounted();

   lastbar= MathMin(HistoryMax, Bars-swing_in-1);

   SetIndexDrawBegin(0, Bars-lastbar);   
   SetIndexDrawBegin(1, Bars-lastbar);

   int j;       
  
   for (shift=0;  shift < lastbar+swing_in;  shift++) {
   
  
   //  iCustom(NULL,0,"SHI_Channel_true",0,shift);
    // double MIDL2=ObjectGet("MIDL",OBJPROP_PRICE2);
    // double MIDL1=ObjectGet("MIDL",OBJPROP_PRICE1);
   //  double TL1  =ObjectGet("TL1" ,OBJPROP_PRICE2);
   //  double TL2  =ObjectGet("TL2" ,OBJPROP_PRICE2);
     //double ChannelSlope = ObjectGet("ChannelSlope2",OBJPROP_PRICE1);
             
     double sar = iSAR(Symbol(),Period(),0.09,0.2, shift);
     double lastsar = iSAR(Symbol(),Period(),0.09,0.2, shift+1);     
     
     
               
   // short
   if  ((sar > High[shift]) && (lastsar < High[shift+1])){
  //if (MIDL2<MIDL1) { // trend check
      if (ConfirmonFasterChart(shift,true, 240) == true ) {
         BufferSellSignals[shift] = High[shift];     
       }
    //  }
    }
     else
     {
       BufferSellSignals[shift] = 0;           
      }
      
         // long
   if  ((sar < Low[shift]) && (lastsar >  Low[shift+1])){
   //if (MIDL2>MIDL1) { // trend check
    if (ConfirmonFasterChart(shift,false, 240) == true ) {
         BufferBuySignals[shift] = Low[shift];     
      }
 //     }
     }
     else
     {
       BufferBuySignals[shift] = 0;           
      }
      
         
   }
   return(0);
}

// here we have to look at the faster charts to work out if we have support there
// which means the sar must be on the right side
bool ConfirmonFasterChart(int shift, bool isashort, int UsePeriod) {
   return(true);   
   int fastperiod, superfastperiod;   
   fastperiod = 1;
   superfastperiod = 1;
   
   if (UsePeriod == 5) {
   fastperiod = 1;
   superfastperiod = 1;
   }
   
   if (UsePeriod == 15) {
   fastperiod = 5;
   superfastperiod = 1;
   }
   
   if (UsePeriod == 30) {
   fastperiod = 15;
   superfastperiod = 1;
   }
   
   if (UsePeriod == 60) {
   fastperiod = 15;
   superfastperiod = 1;
   }
   
   if (UsePeriod == 240) {
   fastperiod = 15;
   superfastperiod = 1;
   }
   
     double fastsar = iSAR(Symbol(),fastperiod,0.09,0.2, shift);
     double superfastsar = iSAR(Symbol(),superfastperiod,0.09,0.2, shift);
     // double lastfastsar = iSAR(Symbol(),fastperiod,0.09,0.2, shift+1);
    
    // double lastfastsar = iSAR(Symbol(),fastperiod,0.09,0.2, shift+1);     
     if (isashort == true) {
         if  ((fastsar > Low[shift]) && (superfastsar > Low[shift])) {
            return(true);
         }
         else
         {
            return(false);
         }
     }
     else
     {
         if  ((fastsar < High[shift]) && (fastsar < High[shift])){
            return(true);
         }
         else
         {
            return(false);
         }
     }
}

bool CheckAdx() {
   double adx = iADX(Symbol(),Period(), 14, PRICE_CLOSE, MODE_MAIN,0);
   if (adx > 22) {
      return(true);
   }
   else {
   return(false);
   }
}