#property  copyright "Copyright  2005, Yura Prokofiev"
#property  link      "Yura.prokofiev@gmail.com"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color2  Lime
#property  indicator_color3  Red
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_width2 2
#property indicator_width3 2
extern int period=10;

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];


int init()
  {
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);

   IndicatorShortName("swapshop");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);

   return(0);
  }


int start()
  {
   //int     period=10;
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,old;
   double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
   double price;
   double MinL=0;
   double MaxH=0;  
   

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;


   for(int i=0; i<Bars; i++)
    {
      ExtBuffer0[i] = 0;
    }


   bool up=true;
   for(i=Bars; i>=0; i--)
     {
 
          ExtBuffer1[i]= CheckAdx(i, OP_SELL);
          ExtBuffer2[i]= CheckAdx(i, OP_BUY);
          
          if (ExtBuffer2[i] > ExtBuffer1[i] )
          { ExtBuffer1[i]=0;}
          else  if (ExtBuffer2[i] < ExtBuffer1[i] )
           { ExtBuffer2[i]=0;}
           else
           { ExtBuffer2[i]=0;
             ExtBuffer1[i]=0;
           }
           ExtBuffer1[i] = 0-ExtBuffer1[i];
           
           string SymbolText = Symbol();   
                 
   if (StringLen(SymbolText) == 7){ 
      SymbolText = StringSubstr(SymbolText, 0,6);
   }
           if (SymbolText == "EURUSD") {  // sell is with interest
                 if ((ExtBuffer1[i] < 0) && (ExtBuffer2[i] >= 0))
                {
                  ExtBuffer2[i] = 0;                
                }
                else
                {
                 ExtBuffer2[i] = 0;  
                 ExtBuffer1[i] = 0;  
                }
                
                if (ExtBuffer1[i] < 0) 
                {ExtBuffer1[i+1] =0;}
           }
     }

   return(0);
  }
  
  // check all filters here, not just adx
int CheckAdx(int i, int OrderTyp) {
 int retval = 0;
   

   if ((checktrigger(i, OrderTyp, 240))==true)
   {retval +=1;}
      
   if ((checktrigger(i, OrderTyp, 1440))==true)
   {retval +=1;}
   
    if ((checktrigger(i, OrderTyp, 10080))==true)
   {retval +=1;}

//    if ((checknewtrend(i, OrderTyp, 240))==true)
 //  {retval +=1;}
      
 //  if ((checknewtrend(i, OrderTyp, 1440))==true)
 //  {retval +=1;}
   
 //   if ((checknewtrend(i, OrderTyp, 10080))==true)
 //  {retval +=1;}

   return(retval);
}

bool checktrigger(int i, int OrderTyp, int usePeriod) {
bool retval = false;
 double TriggerSell = iCustom(Symbol(),usePeriod, "TriggerLines",0, i);
 double TriggerSell2 = iCustom(Symbol(),usePeriod, "TriggerLines",1, i);
 
 double TriggerBuy = iCustom(Symbol(),usePeriod, "TriggerLines",2, i);
 double TriggerBuy2 = iCustom(Symbol(),usePeriod, "TriggerLines",3, i);
 
    if (OrderTyp == OP_BUY)
    {
        if ((TriggerBuy2 < TriggerBuy))
        {retval = true;}
        else
        {retval = false;}
     }
     else if (OrderTyp == OP_SELL) 
     {
        if ((TriggerSell2 > TriggerSell))
        {retval = true;}
        else
        {retval = false;}
     }
 return(retval);    
 }
 
 
 bool checknewtrend(int i, int OrderTyp, int usePeriod) {
 bool retval = false;
 double NewTrendSilver = iCustom(Symbol(),usePeriod, "NewTrend",14,9,0, i);
 double NewTrendOrange = iCustom(Symbol(),usePeriod, "NewTrend",14,9,1, i);

 
  if (OrderTyp == OP_BUY)
    {
      if ((NewTrendSilver > NewTrendOrange)    )
        {            retval= true;                             }
        else
        {            retval= false;                             }
     }
     else if (OrderTyp == OP_SELL) 
     {
     if ((NewTrendSilver < (NewTrendOrange))    )
        {            retval= true;                             }
        else
        {            retval= false;                             }
     }
 return(retval);    
 }
 
 


